/* 
 * tag: ticket digest routines
 */

#include <string.h>
#include <stdio.h>
/* #include <sys/socket.h> */
/* #include <netinet/in.h> */
/* #include <arpa/inet.h> */

#include "ap_config.h"
#include "ap.h"
#include "ap_md5.h"

#include "tkt_digest.h"



/* appropriated from ap_md5_binary in util_md5.c, Apache dist */
static char * 
md5_digest(const unsigned char *buf, int length)
{
  const char *hex = "0123456789abcdef";
  AP_MD5_CTX my_md5;
  unsigned char hash[16];
  char *r, result[33];
  int i;
  
  /*
   * Take the MD5 hash of the string argument.
   */
  
  ap_MD5Init(&my_md5);
  ap_MD5Update(&my_md5, buf, (unsigned int)length);
  ap_MD5Final(hash, &my_md5);
  
  for (i = 0, r = result; i < 16; i++) {
    *r++ = hex[hash[i] >> 4];
    *r++ = hex[hash[i] & 0xF];
  }
  *r = '\0';
  
  return strdup(result);
}


char * 
tkt_digest(const char *ip_addr, char *key, char *uid, char *tokens, char *cargo, unsigned int timestamp) 
{
  unsigned char *buf = malloc (8 + strlen(key) + strlen (uid) + strlen (tokens) + strlen (cargo) + 1);
  unsigned long ip = ntohl(inet_addr(ip_addr));
  int len = 0;
  char *dig;

  if (buf == NULL) 
    return (NULL);

  if (ip == INADDR_NONE) 
    return (NULL);

  buf[0] = (unsigned char ) ((ip & 0xff000000) >> 24);
  buf[1] = (unsigned char ) ((ip & 0xff0000) >> 16);
  buf[2] = (unsigned char ) ((ip & 0xff00) >> 8);
  buf[3] = (unsigned char ) ((ip & 0xff));  

  buf[4] = (unsigned char ) ((timestamp	& 0xff000000) >> 24);
  buf[5] = (unsigned char ) ((timestamp	& 0xff0000) >> 16);
  buf[6] = (unsigned char ) ((timestamp	& 0xff00) >> 8);
  buf[7] = (unsigned char ) ((timestamp	& 0xff));  

  len = 8;
  
  strcpy ((char *)&buf[len], key);
  len += strlen(key);

  strcpy ((char *)&buf[len], uid);
  len += strlen(uid);

  strcpy ((char *)&buf[len], tokens);
  len += strlen(tokens);
  
  strcpy ((char *)&buf[len], cargo);
  len += strlen(cargo);
  
  buf[len] = 0;

/*    printf("Length: %d\n", len); */
  
/*    printf ("[%d][%d][%d][%d]", buf[0], buf[1], buf[2], buf[3]);  */
/*    printf ("[%d][%d][%d][%d]<%s>\n", buf[4], buf[5], buf[6], buf[7], &buf[8]);  */

  dig = md5_digest(buf, len);

/*    printf("digest0:<%s>\n", dig); */
  
  len = MD5_DIGEST_SZ + strlen (key);
  buf = realloc (buf, len);
  memcpy (buf, dig, MD5_DIGEST_SZ);
  free(dig);						  /* strdupped */
   
  memcpy (&buf[MD5_DIGEST_SZ], key, len - MD5_DIGEST_SZ);

  dig = md5_digest(buf, len);

  free(buf);

  return (dig);
}

